import os
import sys


# http://stackoverflow.com/questions/11130156
class suppress_stdout_stderr(object):
    def __init__(self):
        self.null_fds = [os.open(os.devnull, os.O_RDWR) for x in range(2)]
        self.save_fds = (os.dup(1), os.dup(2))

    def __enter__(self):
        os.dup2(self.null_fds[0], 1)
        os.dup2(self.null_fds[1], 2)

    def __exit__(self, *_):
        os.dup2(self.save_fds[0], 1)
        os.dup2(self.save_fds[1], 2)
        os.close(self.null_fds[0])
        os.close(self.null_fds[1])


def main():
    if len(sys.argv) > 1 and sys.argv[1] == 'cleanbin':
        from .cleanbin import cleanbin
        cleanbin()
    else:
        from .airship import sync
        with suppress_stdout_stderr():
            sync()
